\ ############################################################################
\ # toggle.fth - This program starts up a Forth cog that toggles P15
\ #
\ # Copyright (c) 2012 Dave Hein
\ # MIT Licensed
\ ############################################################################

create cogstack  80 allot     \ Allocate data stack space
create cogreturn 80 allot     \ Allocate return stack space
create delaycnt  80000000 ,   \ This variable controls the blink rate

hex
\ This word toggles bit P15 every "delaycnt" cycles
: toggle
  8000 dirasetbit cnt@        \ Set P15 for output and get CNT
  begin
    delaycnt @ + waitcnt      \ Wait "delaycnt" cycles
    8000 outasetbit           \ Set P15
    delaycnt @ + waitcnt      \ Wait "delaycnt" cycles
    8000 outaclrbit           \ Clear P15
    false                     \ Load FALSE so UNTIL loops back
  until ;
decimal

create cogconfig              \ Forth cog config structure
  ' toggle >body ,            \ Get execution token for TOGGLE
  cogstack ,                  \ Initial value of stack ptr
  cogstack ,                  \ Empty value for stack ptr
  cogreturn ,                 \ Initial value of return ptr
  cogreturn ,                 \ Empty value for return ptr

\ This word starts a cog running the TOGGLE word
: starttoggle forth @ cogconfig cognew ;

\ +--------------------------------------------------------------------
\ |  TERMS OF USE: MIT License
\ +--------------------------------------------------------------------
\ Permission is hereby granted, free of charge, to any person obtaining
\ a copy of this software and associated documentation files
\ (the "Software"), to deal in the Software without restriction,
\ including without limitation the rights to use, copy, modify, merge,
\ publish, distribute, sublicense, and/or sell copies of the Software,
\ and to permit persons to whom the Software is furnished to do so,
\ subject to the following conditions:
\ 
\ The above copyright notice and this permission notice shall be
\ included in all copies or substantial portions of the Software.
\ 
\ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
\ EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
\ MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
\ IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
\ CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
\ TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
\ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
\ +------------------------------------------------------------------
